unit Unit1;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, Controls,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWIPhoneMenu,
  IWIPhoneTrackbar, IWIPhonePhoneLabel, IWIPhoneSMSLabel, IWIPhoneEmailLabel,
  IWCompLabel, IWIPhoneList, IWIPhoneHeader, Forms,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion,
  IWIPhonePageFlip, IWCompEdit, IWIPhoneButton, IWIPhoneStyle,
  IWIPhoneOnOffButton, DB, ADODB, IWIPhoneRegion, Variants,
  IWIPhoneLocationLabel, IWIPhoneGeolocation, IWIPhonePopup, IWIPhoneSpinner,
  IWCompExtCtrls;

type
  TIWForm1 = class(TIWAppForm)
    RegionModels: TTIWIPhoneRegion;
    ListModels: TTIWIPhoneList;
    HeaderModels: TTIWIPhoneHeader;
    RegionModelDetail: TTIWIPhoneRegion;
    HeaderModelDetail: TTIWIPhoneHeader;
    IWImageFile1: TIWImageFile;
    LabelName: TIWLabel;
    TIWIPhoneEmailLabel1: TTIWIPhoneEmailLabel;
    EditEmail: TIWEdit;
    EditTel: TIWEdit;
    TIWIPhonePhoneLabel1: TTIWIPhonePhoneLabel;
    LabelScore: TIWLabel;
    LabelScoreValue: TIWLabel;
    TrackbarScore: TTIWIPhoneTrackbar;
    IWLabel1: TIWLabel;
    RegionStats: TTIWIPhoneRegion;
    HeaderStats: TTIWIPhoneHeader;
    ListStats: TTIWIPhoneList;
    RegionSettings: TTIWIPhoneRegion;
    TIWIPhoneHeader1: TTIWIPhoneHeader;
    IWLabel2: TIWLabel;
    LabelImages: TIWLabel;
    LabelDetails: TIWLabel;
    IWLabel4: TIWLabel;
    OnOffImages: TTIWIPhoneOnOffButton;
    OnOffDetails: TTIWIPhoneOnOffButton;
    OnOffRounded: TTIWIPhoneOnOffButton;
    ButtonSave: TTIWIPhoneButton;
    EditComment: TIWEdit;
    IWLabel3: TIWLabel;
    TIWIPhoneButton1: TTIWIPhoneButton;
    TIWIPhoneLocationLabel1: TTIWIPhoneLocationLabel;
    TIWIPhoneMenu1: TTIWIPhoneMenu;
    LabelBirthDate: TIWLabel;
    ButtonBirthDate: TTIWIPhoneButton;
    IWLabel5: TIWLabel;
    TIWIPhonePageFlip1: TTIWIPhonePageFlip;
    TIWIPhoneStyle1: TTIWIPhoneStyle;
    TIWIPhoneGeolocation1: TTIWIPhoneGeolocation;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    DataSource1: TDataSource;
    IWRegion1: TIWRegion;
    SpinnerBirthDate: TTIWIPhoneSpinner;
    TIWIPhonePopup1: TTIWIPhonePopup;
    procedure IWAppFormCreate(Sender: TObject);
    procedure HeaderModelDetailAsyncLeftButtonClick(Sender: TObject;
      EventParams: TStringList);
    procedure HeaderModelDetailAsyncRightButtonClick(Sender: TObject;
      EventParams: TStringList);
    procedure ListModelsAsyncItemClick(Sender: TObject;
      EventParams: TStringList; ItemIndex: Integer);
    procedure TIWIPhoneMenu1ItemClick(Sender: TComponent; ItemIndex: Integer);
    procedure ButtonSaveButtonClick(Sender: TObject);
    procedure ListModelsRenderListItem(Sender: TComponent; ItemIndex: Integer;
      var Caption, Notes, Value, Image: string; var Detail: Boolean);
    procedure TIWIPhoneGeolocation1AsyncLocationRetrieved(Sender: TObject;
      EventParams: TStringList; Location: string; Latitude, Longitude: Double);
    procedure TIWIPhoneButton1AsyncButtonClick(Sender: TObject;
      EventParams: TStringList);
    procedure ButtonBirthDateAsyncButtonClick(Sender: TObject;
      EventParams: TStringList);
  public
    procedure UpdateModelDetails(ItemIndex: Integer);
  end;

implementation

{$R *.dfm}


procedure TIWForm1.ButtonBirthDateAsyncButtonClick(Sender: TObject;
  EventParams: TStringList);
begin

  if not TIWIPhonePopup1.ShowPopup then
  begin
    TIWIPhonePopup1.PositionType := ptAtControl;
    TIWIPhonePopup1.PositionControl := ButtonBirthDate;
    TIWIPhonePopup1.ArrowPosition := apBottomRight;
    TIWIPhonePopup1.ContentRegion := IWRegion1;
    TIWIPhonePopup1.ShowPopup := true;
    ButtonBirthDate.Caption := 'Close';
  end
  else
  begin

    LabelBirthDate.Text := DateToStr(
      EncodeDate(StrToInt(SpinnerBirthDate.Slots[2].Items[SpinnerBirthDate.Slots[2].SelectedIndex]),
      StrToInt(SpinnerBirthDate.Slots[1].Items[SpinnerBirthDate.Slots[1].SelectedIndex]),
      StrToInt(SpinnerBirthDate.Slots[0].Items[SpinnerBirthDate.Slots[0].SelectedIndex])));

    ButtonBirthDate.Caption := 'Change';
    TIWIPhonePopup1.ShowPopup := false;
  end;
end;

procedure TIWForm1.ButtonSaveButtonClick(Sender: TObject);
var
  I: integer;
begin

  if OnOffImages.ButtonState = bsOn then
  begin
   ListModels.ItemAppearance.ShowImage := true;
   ListModels.ItemAppearance.NotesMargins.Left := 35;
  end
  else
  begin
   ListModels.ItemAppearance.ShowImage := false;
   ListModels.ItemAppearance.NotesMargins.Left := 0;
  end;

  for I := 0 to ListModels.Items.Count - 1 do
  begin
    if OnOffDetails.ButtonState = bsOn then
      ListModels.Items[I].Detail := true
    else
      ListModels.Items[I].Detail := false;
  end;

  if OnOffRounded.ButtonState = bsOn then
  begin
    ListModels.ListType := ltSettings;
    ListModels.ItemAppearance.Padding := 0;
  end
  else
  begin
    ListModels.ListType := ltNormal;
    ListModels.ItemAppearance.Padding := 5;
  end;

  //Return to Models List page
  TIWIPhoneMenu1.SelectedIndex := 0;

  TIWIPhonePageFlip1.Visible := true;
  RegionModels.Visible := true;
  RegionModelDetail.Visible := true;
  RegionStats.Visible := false;
  RegionSettings.Visible := false;
end;

procedure TIWForm1.HeaderModelDetailAsyncLeftButtonClick(Sender: TObject;
  EventParams: TStringList);
begin
  TIWIPhonePageFlip1.SlideToFront;
end;

procedure TIWForm1.HeaderModelDetailAsyncRightButtonClick(Sender: TObject;
  EventParams: TStringList);
var
  country, street, address: string;
  i: integer;
begin
  address := TIWIPhoneLocationLabel1.Caption;
  street := EmptyStr;
  country := EmptyStr;

  if address <> EmptyStr then
  begin
    i := LastDelimiter(', ', address);
    country := Copy(address, i+1, length(address));
    street := Copy(address, 0, i-2);
  end;

  ListModels.Items[ListModels.SelectedIndex].Data.Clear;
  ListModels.Items[ListModels.SelectedIndex].Data.Add(EditEmail.Text);
  ListModels.Items[ListModels.SelectedIndex].Data.Add(EditTel.Text);
//  ListModels.Items[ListModels.SelectedIndex].Data.Add(EditSMS.Text);
  ListModels.Items[ListModels.SelectedIndex].Data.Add('');

  if country <> EmptyStr then
    ListModels.Items[ListModels.SelectedIndex].Data.Add(country)
  else
    ListModels.Items[ListModels.SelectedIndex].Data.Add(' ');

  ListModels.Items[ListModels.SelectedIndex].Data.Add(EditComment.Text);

  if street <> EmptyStr then
    ListModels.Items[ListModels.SelectedIndex].Data.Add(street)
  else
    ListModels.Items[ListModels.SelectedIndex].Data.Add(' ');

  ListModels.Items[ListModels.SelectedIndex].Data.Add(LabelBirthDate.Text);

  ListModels.Items[ListModels.SelectedIndex].Value := IntToStr(TrackbarScore.ThumbPosition);

  ADOQuery1.SQL.Clear;
  ADOQuery1.SQL.Add('SELECT * FROM [Models] ORDER BY [Name]');
  ADOQuery1.Active := true;

  DataSource1.DataSet.First;
  DataSource1.DataSet.MoveBy(ListModels.SelectedIndex);
  DataSource1.DataSet.Edit;
  DataSource1.DataSet.FieldByName('Email').Value := EditEmail.Text;
  DataSource1.DataSet.FieldByName('Tel').Value := EditTel.Text;
//  DataSource1.DataSet.FieldByName('SMS').Value := EditSMS.Text;
  DataSource1.DataSet.FieldByName('Comment').Value := EditComment.Text;
  DataSource1.DataSet.FieldByName('Score').Value := IntToStr(TrackbarScore.ThumbPosition);
  if country <> EmptyStr then
    DataSource1.DataSet.FieldByName('Country').Value := country;
  if street <> EmptyStr then
    DataSource1.DataSet.FieldByName('Address').Value := street;
  DataSource1.DataSet.FieldByName('Birthdate').Value := LabelBirthDate.Text;
  DataSource1.DataSet.Post;

  ADOQuery1.SQL.Clear;
  ADOQuery1.SQL.Add('SELECT Count(ID) as CountOfID FROM [Models] WHERE Score <= 0');
  ADOQuery1.Active := true;

  TIWIPhoneMenu1.Items[0].IndicatorCaption := DataSource1.DataSet.FieldByName('CountOfID').Value;

  TIWIPhonePageFlip1.SlideToFront;
end;

procedure TIWForm1.IWAppFormCreate(Sender: TObject);
var
  I: integer;
  Year, Month, Day: Word;
begin

  FormatSettings.ShortDateFormat := 'd/mm/yyyy';

  DecodeDate(Now, Year, Month, Day);
  SpinnerBirthDate.YearFrom := Year - 40;
  SpinnerBirthDate.YearTo := Year;

  TIWIPhonePageFlip1.Align := alClient;

  TIWIPhoneStyle1.IconImage := '/Files/tms_icon.png';
  TIWIPhoneStyle1.StartupImage := '/Files/splashtms.png';

  ADOConnection1.ConnectionString :=
    'Provider=Microsoft.Jet.OLEDB.4.0;Password="";Persist Security Info=True;Data Source= ' +
  WebApplication.ApplicationPath + 'data.mdb';

  ADOQuery1.Connection := ADOConnection1;

  ADOQuery1.SQL.Clear;
  ADOQuery1.SQL.Add('SELECT Count(ID) as CountOfID FROM [Models] WHERE Score <= 0');
  ADOQuery1.Active := true;

  DataSource1.DataSet := ADOQuery1;
  DataSource1.DataSet.Active := true;

  TIWIPhoneMenu1.Items.Clear;
  for I := 0 to 3 - 1 do
  begin
    TIWIPhoneMenu1.Items.Add();
  end;

  TIWIPhoneMenu1.Items.Clear;
  for I := 0 to 3 - 1 do
  begin
    TIWIPhoneMenu1.Items.Add();
  end;

  TIWIPhoneMenu1.Items[0].Caption := 'Models';
  TIWIPhoneMenu1.Items[0].Image := '/files/star.png';
  TIWIPhoneMenu1.Items[0].SelectedImage := '/files/star_s.png';

  TIWIPhoneMenu1.Items[0].IndicatorVisible := True;
  //TIWIPhoneMenu1.Items[0].IndicatorCaption := IntToStr(ListModels.Items.Count);
  TIWIPhoneMenu1.Items[0].IndicatorCaption := DataSource1.DataSet.FieldByName('CountOfID').Value;

  TIWIPhoneMenu1.Items[1].Caption := 'Stats';
  TIWIPhoneMenu1.Items[1].Image := '/files/graph.png';
  TIWIPhoneMenu1.Items[1].SelectedImage := '/files/graph_s.png';

  TIWIPhoneMenu1.Items[2].Caption := 'Settings';
  TIWIPhoneMenu1.Items[2].Image := '/files/preferences.png';
  TIWIPhoneMenu1.Items[2].SelectedImage := '/files/preferences_s.png';

  TIWIPhoneMenu1.SelectedIndex := 0;

  ADOQuery1.SQL.Clear;
  ADOQuery1.SQL.Add('SELECT * FROM [Models] ORDER BY [Name]');
  ADOQuery1.Active := true;

  ListModels.Items.Clear;

  DataSource1.DataSet.First;
  while not DataSource1.DataSet.Eof do
  begin
    with ListModels.Items.Add() do
    begin
      Detail := true;

      if (DataSource1.DataSet.FieldByName('Image').Value <> '') then
        Image := '/files/' + DataSource1.DataSet.FieldByName('Image').Value;

      Caption := DataSource1.DataSet.FieldByName('Name').Value;
      Value := DataSource1.DataSet.FieldByName('Score').Value;
      Notes := DataSource1.DataSet.FieldByName('Country').Value;
      Tag := DataSource1.DataSet.FieldByName('ID').Value;

      Data.Add(DataSource1.DataSet.FieldByName('Email').Value);
      Data.Add(DataSource1.DataSet.FieldByName('Tel').Value);
      Data.Add(DataSource1.DataSet.FieldByName('SMS').Value);
      Data.Add(DataSource1.DataSet.FieldByName('Country').Value);

      if not VarIsNull(DataSource1.DataSet.FieldByName('Comment').Value) then
        Data.Add(DataSource1.DataSet.FieldByName('Comment').Value)
      else
        Data.Add('');

      Data.Add(DataSource1.DataSet.FieldByName('Address').Value);
      Data.Add(DateToStr(DataSource1.DataSet.FieldByName('Birthdate').AsDateTime));

    end;
    DataSource1.DataSet.Next;
  end;

  ListModels.ItemAppearance.Height := 50;
  ListModels.ItemAppearance.DetailMargins.Top := 10;
  ListModels.ItemAppearance.DetailMargins.Left := 2;

  RegionStats.Align := alClient;
  RegionStats.Visible := false;
  RegionSettings.Align := alClient;
  RegionSettings.Visible := false;

end;

procedure TIWForm1.UpdateModelDetails(ItemIndex: Integer);
begin
    IWImageFile1.ImageFile.URL := ListModels.Items[ItemIndex].Image;

    LabelName.Text := ListModels.Items[ItemIndex].Caption;
    EditEmail.Text := ListModels.Items[ItemIndex].Data.Strings[0];
    TIWIPhoneEmailLabel1.EmailAddress := EditEmail.Text;
    EditTel.Text := ListModels.Items[ItemIndex].Data.Strings[1];
    TIWIPhonePhoneLabel1.TelephoneNumber := EditTel.Text;
//    EditSMS.Text := ListModels.Items[ItemIndex].Data.Strings[2];
//    TIWIPhoneSMSLabel1.SMSNumber := EditSMS.Text;
    EditComment.Text := ListModels.Items[ItemIndex].Data.Strings[4];
    TIWIPhoneLocationLabel1.Caption := ListModels.Items[ItemIndex].Data.Strings[5]
    + ', ' + ListModels.Items[ItemIndex].Data.Strings[3];

    LabelBirthDate.Text := ListModels.Items[ItemIndex].Data.Strings[6];
    SpinnerBirthDate.Date := StrToDate(LabelBirthDate.Text);

    TIWIPhoneLocationLabel1.Location := TIWIPhoneLocationLabel1.Caption;
    TrackbarScore.ThumbPosition := StrToInt(ListModels.Items[ItemIndex].Value);
    LabelScoreValue.Text := IntToStr(TrackbarScore.ThumbPosition);
end;

procedure TIWForm1.ListModelsAsyncItemClick(Sender: TObject;
  EventParams: TStringList; ItemIndex: Integer);
begin
    UpdateModelDetails(ItemIndex);
    TIWIPhonePageFlip1.SlideToBack;
end;

procedure TIWForm1.ListModelsRenderListItem(Sender: TComponent;
  ItemIndex: Integer; var Caption, Notes, Value, Image: string;
  var Detail: Boolean);
begin
  Notes := ListModels.Items[ItemIndex].Data.Strings[3];
  if ListModels.Items[ItemIndex].Data.Strings[4] <> EmptyStr then
    Notes := Notes + ' - ' + ListModels.Items[ItemIndex].Data.Strings[4];
end;

procedure TIWForm1.TIWIPhoneButton1AsyncButtonClick(Sender: TObject;
  EventParams: TStringList);
begin
  TIWIPhoneGeolocation1.RetrieveLocation;
end;

procedure TIWForm1.TIWIPhoneGeolocation1AsyncLocationRetrieved(Sender: TObject;
  EventParams: TStringList; Location: string; Latitude, Longitude: Double);
begin
  TIWIPhoneLocationLabel1.Location := Location;
  TIWIPhoneLocationLabel1.Caption := Location;
end;

procedure TIWForm1.TIWIPhoneMenu1ItemClick(Sender: TComponent;
  ItemIndex: Integer);
begin
  if (ItemIndex = 0) then
  begin
    TIWIPhonePageFlip1.Visible := true;
    RegionModels.Visible := true;
    RegionModelDetail.Visible := true;
    RegionStats.Visible := false;
    RegionSettings.Visible := false;
  end
  else if (ItemIndex = 1) then
  begin

    ListStats.Items.Clear;
    ListStats.ListType := ltSettings;

    with ListStats.Items.Add() do
    begin
      Section := true;
      Caption := 'Countries';
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Country, Count(Models.[Country]) AS CountOfCountry FROM Models GROUP BY Models.Country');
    ADOQuery1.Active := true;

    DataSource1.DataSet.First;
    while not DataSource1.DataSet.Eof do
    begin
      with ListStats.Items.Add() do
      begin
        Caption := DataSource1.DataSet.FieldByName('Country').Value;
        Value := DataSource1.DataSet.FieldByName('CountOfCountry').Value;
        Image := '/Files/' + DataSource1.DataSet.FieldByName('Country').Value + '.png';
      end;
      DataSource1.DataSet.Next;
    end;

    with ListStats.Items.Add() do
    begin
      Section := true;
      Caption := 'Scores';
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Count(Score) AS CountOfScore FROM Models WHERE (Score = 0)');
    ADOQuery1.Active := true;

    with ListStats.Items.Add() do
    begin
      Caption := 'Not Rated';
      Value := DataSource1.DataSet.FieldByName('CountOfScore').Value;
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Count(Score) AS CountOfScore FROM Models WHERE (Score > 0) AND (Score <= 25)');
    ADOQuery1.Active := true;

    with ListStats.Items.Add() do
    begin
      Caption := '1 - 25';
      Value := DataSource1.DataSet.FieldByName('CountOfScore').Value;
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Count(Score) AS CountOfScore FROM Models WHERE (Score > 25) AND (Score <= 50)');
    ADOQuery1.Active := true;

    with ListStats.Items.Add() do
    begin
      Caption := '26 - 50';
      Value := DataSource1.DataSet.FieldByName('CountOfScore').Value;
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Count(Score) AS CountOfScore FROM Models WHERE (Score > 50) AND (Score <= 75)');
    ADOQuery1.Active := true;

    with ListStats.Items.Add() do
    begin
      Caption := '51 - 75';
      Value := DataSource1.DataSet.FieldByName('CountOfScore').Value;
    end;

    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT Count(Score) AS CountOfScore FROM Models WHERE (Score > 75)');
    ADOQuery1.Active := true;

    with ListStats.Items.Add() do
    begin
      Caption := '76 - 100';
      Value := DataSource1.DataSet.FieldByName('CountOfScore').Value;
    end;

    TIWIPhonePageFlip1.Visible := false;
    RegionModels.Visible := false;
    RegionModelDetail.Visible := false;
    RegionStats.Visible := true;
    RegionSettings.Visible := false;
  end
  else if (ItemIndex = 2) then
  begin
    TIWIPhonePageFlip1.Visible := false;
    RegionModels.Visible := false;
    RegionModelDetail.Visible := false;
    RegionStats.Visible := false;
    RegionSettings.Visible := true;
  end;
end;

initialization
  TIWForm1.SetAsMainForm;

end.
